--------------------------------------------------------------------------------
-- Problem P1 (plan C2)
---------------------------------------------------
-- Asynchronous circuit 
-- P5 - CSD 
-- http://digsys.upc.edu
--------------------------------------------------------------------------------

LIBRARY ieee;
USE  IEEE.STD_LOGIC_1164.all;

ENTITY Circuit_P1 IS
	PORT (
		X, CLK, CD	: 	IN 	STD_LOGIC;  
		F			: 	OUT	STD_LOGIC;
		
			A1, B1, C1			: 	OUT	STD_LOGIC	
		
		
	  );

END Circuit_P1;

ARCHITECTURE hierarchical_structure OF Circuit_P1 IS
	
-- The elemental components to be used:
	COMPONENT MUX_2 IS  
		PORT (
			Ch0, Ch1	: 	IN 	STD_LOGIC;  -- 1 bits per channel
			S			:	IN 	STD_LOGIC;	-- to select 2 channels
			E_L			: 	IN 	STD_LOGIC;
			Y			: 	OUT	STD_LOGIC
		  );
	END COMPONENT;

	COMPONENT D_FF IS  
		Port (	
			CLK 	: IN	STD_LOGIC;
			CD 		: IN	STD_LOGIC;
			D		: IN	STD_LOGIC;
			Q 		: OUT	STD_LOGIC
		);
	END COMPONENT;

	COMPONENT T_FF IS  
		Port (	
			CLK 	: IN	STD_LOGIC;
			CD 		: IN	STD_LOGIC;
			T		: IN	STD_LOGIC;
			Q 		: OUT	STD_LOGIC
		);
	END COMPONENT;
	

	
-- Signals
SIGNAL A, B, C, D:	STD_LOGIC; -- internal wires


BEGIN

-- Instantiation of up to 4 basic 1-bit adders:

	Chip2	: MUX_2
		PORT MAP (
-- from component name 	=> to signal or port name
				E_L		=> '0',
				Ch1		=> D,
				Ch0		=> B, 
				S		=> X,
				Y		=> C			
		);

	Chip1	: D_FF
		PORT MAP (
-- from component name 	=> to signal or port name
				CLK		=> CLK,
				CD		=> CD,
				D		=> X, 
				Q		=> A
			
		);

	Chip3	: T_FF
		PORT MAP (
-- from component name 	=> to signal or port name
				CLK		=> C,
				CD		=> CD,
				T		=> B, 
				Q		=> D
			
		);

-- Other circuits and equations:
B <= not (A and D);
F <= D;
A1 <= A;
B1 <= B;
C1 <= C;

			 		   	 		 		   	   
END hierarchical_structure;
