-- Copyright (C) 2020  Intel Corporation. All rights reserved.
-- Your use of Intel Corporation's design tools, logic functions 
-- and other software and tools, and any partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Intel Program License 
-- Subscription Agreement, the Intel Quartus Prime License Agreement,
-- the Intel FPGA IP License Agreement, or other applicable license
-- agreement, including, without limitation, that your use is for
-- the sole purpose of programming logic devices manufactured by
-- Intel and sold by Intel or its authorized distributors.  Please
-- refer to the applicable agreement for further details, at
-- https://fpgasoftware.intel.com/eula.

-- ***************************************************************************
-- This file contains a Vhdl test bench template that is freely editable to   
-- suit user's needs .Comments are provided in each section to help the user  
-- fill out necessary details.                                                
-- ***************************************************************************
-- Generated on "01/20/2022 20:19:51"
                                                            
-- Vhdl Test Bench template for design  :  Circuit_P1
-- 
-- Simulation tool : ModelSim-Altera (VHDL)
-- 

LIBRARY ieee;                                               
USE ieee.std_logic_1164.all;                                

ENTITY Circuit_P1_vhd_tst IS
END Circuit_P1_vhd_tst;
ARCHITECTURE Circuit_P1_arch OF Circuit_P1_vhd_tst IS
-- constants                                                 
-- signals                                                   
SIGNAL CD : STD_LOGIC;
SIGNAL CLK : STD_LOGIC;
SIGNAL F : STD_LOGIC;
SIGNAL X : STD_LOGIC;
COMPONENT Circuit_P1
	PORT (
	CD : IN STD_LOGIC;
	CLK : IN STD_LOGIC;
	F : OUT STD_LOGIC;
	X : IN STD_LOGIC
	);
END COMPONENT;


   -- Clock period definitions
   constant CLK_period : time := 1 ms; -- Meaning a F_CLK = 1 kHz
										-- Run simulation for 10 ms


BEGIN
	i1 : Circuit_P1
	PORT MAP (
-- list connections between master ports and signals
	CD => CD,
	CLK => CLK,
	F => F,
	X => X
	);


	   -- Clock process definitions
   CLK_process :process
   begin
		CLK <= '0';
		wait for CLK_period/2;
		CLK <= '1';
		wait for CLK_period/2; -- Duty cycle of 25%
   end process;	


   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
      wait for 100 ns;	
      wait for CLK_period*1.3;
	
		CD <= '0';  -- This time only CD is required as input
      wait for CLK_period*1.56;

		X <= '0';
      -- Clear direct 
		CD <= '1';
      wait for CLK_period*1.56;
		
		CD <= '0';
      wait for CLK_period*1.4;

		X <= '0';
      wait for CLK_period*1.4;

		X <= '1';
      wait for CLK_period*2.4;

		X <= '0';
      wait for CLK_period*3.4;


		X <= '1';
      wait for CLK_period*2.4;

		X <= '0';
      wait for CLK_period*5.4;


      wait; 
      
      -- end of user generated stimulus
  
   end process stim_proc;



                                         
END Circuit_P1_arch;
